# Viewing Details of a Forwarding Policy

#### Function

This API is used to view details of a forwarding policy.

#### URI

GET /v3/{project_id}/elb/l7policies/{l7policy_id}

Table 1 Path parameters
Parameter | Mandatory | Type | Description
--- | --- | --- | ---
project_id | Yes | String | Specifies the project ID.
l7policy_id | Yes | String | Specifies the forwarding policy ID.

#### Request Parameters

Table 2 Request header parameters
Parameter | Mandatory | Type | Description
--- | --- | --- | ---
X-Auth-Token | Yes | String | Specifies the token used for IAM authentication.

#### Response Parameters

Status code: 200

Table 3 Response body parameters
Parameter | Type | Description
--- | --- | ---
request_id | String | Specifies the request ID. The value is automatically generated.
l7policy | L7Policy object | Specifies the forwarding policy.

Table 4 L7Policy
Parameter | Type | Description
--- | --- | ---

action

String

Specifies where requests will be forwarded. The value can be one of the following:

- REDIRECT_TO_POOL: Requests will be forwarded to another backend server group.

- REDIRECT_TO_LISTENER: Requests will be redirected to an HTTPS listener.

REDIRECT_TO_LISTENER has the highest priority. If requests are to be redirected to an HTTPS listener, other forwarding policies of the listener will become invalid.

admin_state_up | Boolean | Specifies the administrative status of the forwarding policy. The default value is true. This parameter is unsupported. Please do not use it. Default: true
description | String | Provides supplementary information about the forwarding policy.
id | String | Specifies the forwarding policy ID.

listener_id

String

Specifies the ID of the listener to which the forwarding policy is added.

- If action is set to REDIRECT_TO_POOL, the forwarding policy can be added to an HTTP or HTTPS listener.

- If action is set to REDIRECT_TO_LISTENER, the forwarding policy can be added to an HTTP listener.

name | String | Specifies the forwarding policy name. Minimum: 1 Maximum: 255
position | Integer | Specifies the forwarding policy priority. This parameter cannot be updated. This parameter is unsupported. Please do not use it. Minimum: 1 Maximum: 100
project_id | String | Specifies the project ID of the forwarding policy.
provisioning_status | String | Specifies the provisioning status of the forwarding policy. The value can only be ACTIVE. Default: ACTIVE
redirect_listener_id | String | Specifies the ID of the listener that requests are redirected to. This parameter is valid and mandatory only when action is set to REDIRECT_TO_LISTENER. Only HTTPS listeners are supported, and the listener cannot be any listener added to other load balancers.

redirect_pool_id

String

Specifies the ID of the backend server group that requests are forwarded to.

This parameter is valid and mandatory only when action is set to REDIRECT_TO_POOL.

The specified backend server group cannot be the default one associated with the listener, or any backend server group associated with the forwarding policies of other listeners.

This parameter cannot be specified when action is set to REDIRECT_TO_LISTENER.

redirect_url | String | Specifies the URL to which requests are forwarded. Format: protocol://host:port/path?query This parameter is unsupported. Please do not use it.
rules | Array of RuleRef objects | Lists the forwarding rules in the forwarding policy.

redirect_url_config

RedirectUrlConfig object

Specifies the URL to which requests are forwarded.

For shared load balancers, this parameter is not supported. If it is passed, an error will be returned.

For dedicated load balancers, this parameter will take effect only when advanced forwarding is enabled (enhance_l7policy_enable is set to true). If it is passed when enhance_l7policy_enable is set to false, an error will be returned.

Format: protocol://host:port/path?query

At least one of the four parameters (protocol, host, port, and path) must be passed, or their values cannot be set to ${xxx} at the same time. (${xxx} indicates that the value in the request will be inherited. For example, ${host} indicates the host in the URL to be redirected.)

The values of protocol and port cannot be the same as those of the associated listener, and either host or path must be passed or their values cannot be ${xxx} at the same time.

This parameter is unsupported. Please do not use it.

fixed_response_config

FixtedResponseConfig object

Specifies the configuration of the page that will be returned. This parameter will take effect when enhance_l7policy_enable is set to true. If this parameter is passed and enhance_l7policy_enable is set to false, an error will be returned. For shared load balancers, this parameter is not supported. If it is passed, an error will be returned.

This parameter is unsupported. Please do not use it.

priority

Integer

Specifies the forwarding policy priority. This parameter is available only for dedicated load balancers and will take effect when enhance_l7policy_enable is set to true.

A smaller value indicates a higher priority. The value must be unique for each forwarding policy of the same listener.

If action is set to REDIRECT_TO_LISTENER, the value can only be 0, indicating that REDIRECT_TO_LISTENER has the highest priority.

- If enhance_l7policy_enable is set to false, forwarding policies are automatically prioritized based on the original sorting logic. Forwarding policy priorities are independent of each other regardless of domain names. If forwarding policies use the same domain name, their priorities follow the order of exact match (EQUAL_TO), prefix match (STARTS_WITH), and regular expression match (REGEX). If prefix match is used for matching, the longer the path, the higher the priority. If a forwarding policy contains only a domain name without a path specified, the path is /, and prefix match is used by default.

- If enhance_l7policy_enable is set to true and this parameter is not passed, the priority will set to a sum of 1 and the highest priority of existing forwarding policy in the same listener by default. There will be two cases: a) If the highest priority of existing forwarding policies is the maximum (10,000), the forwarding policy will fail to create because the final priority for creating the forwarding policy is the sum of 1 and 10,000, which exceeds the maximum. In this case, please specify a value or adjust the priorities of existing forwarding policies. b) If no forwarding policies exist, the highest priority of existing forwarding policies will set to 1 by default.

This parameter is unsupported. Please do not use it.

Minimum: 0

Maximum: 10000

Table 5 RuleRef
Parameter | Type | Description
--- | --- | ---
id | String | Specifies the forwarding rule ID.

Table 6 RedirectUrlConfig
Parameter | Type | Description
--- | --- | ---

protocol

String

Specifies the protocol for redirection. The default value is ${protocol}, indicating that the protocol of the request will be used.

Value options:

- HTTP

- HTTPS

- ${protocol}

Minimum: 1

Maximum: 36

host | String | Specifies the host name that requests are redirected to. The value can contain only letters, digits, hyphens (-), and periods (.) and must start with a letter or digit. The default value is ${host}, indicating that the host of the request will be used. Default: ${host} Minimum: 1 Maximum: 128
port | String | Specifies the port that requests are redirected to. The default value is ${port}, indicating that the port of the request will be used. Default: ${port} Minimum: 1 Maximum: 16
path | String | Specifies the path that requests are redirected to. The default value is ${path}, indicating that the path of the request will be used. The value can contain only letters, digits, and special characters _-';@^- %#&$.*+?,=!:|/()[]{} and must start with a slash (/). Default: ${path} Minimum: 1 Maximum: 128

query

String

Specifies the query string set in the URL for redirection. The default value is ${query}, indicating that the query string of the request will be used.

For example, in the URL https://www.xxx.com:8080/elb?type=loadbalancer, ${query} indicates type=loadbalancer. If this parameter is set to ${query}&name=my_name, the URL will be redirected to https://www.xxx.com:8080/elb?type=loadbalancer&name=my_name.

The value is case-sensitive and can contain only letters, digits, and special characters !$&'()*+,-./:;=?@^_`

Default: ${query}

Minimum: 0

Maximum: 128

status_code

String

Specifies the status code returned after the requests are redirected.

Value options:

- 301

- 302

- 303

- 307

- 308

Minimum: 1

Maximum: 16

Table 7 FixtedResponseConfig
Parameter | Type | Description
--- | --- | ---
status_code | String | Specifies the HTTP status code configured in the forwarding policy. The value can be any integer in the range of 200–299, 400–499, or 500–599. Minimum: 1 Maximum: 16

content_type

String

Specifies the format of the response body.

Value options:

- text/plain

- text/css

- text/html

- application/javascript

- application/json

Minimum: 0

Maximum: 32

message_body | String | Specifies the content of the response body. Minimum: 0 Maximum: 1024

#### Example Requests

    GET

    https://{elb_endpoint}/v3/99a3fff0d03c428eac3678da6a7d0f24/elb/l7policies/cf4360fd-8631-41ff-a6f5-b72c35da74be

#### Example Responses

Status code: 200

Successful request.

    {
      "l7policy" : {
        "description" : "",
        "admin_state_up" : true,
        "rules" : [ ],
        "project_id" : "99a3fff0d03c428eac3678da6a7d0f24",
        "listener_id" : "e2220d2a-3faf-44f3-8cd6-0c42952bd0ab",
        "redirect_listener_id" : "48a97732-449e-4aab-b561-828d29e45050",
        "action" : "REDIRECT_TO_LISTENER",
        "position" : 100,
        "provisioning_status" : "ACTIVE",
        "id" : "cf4360fd-8631-41ff-a6f5-b72c35da74be",
        "name" : ""
      },
      "request_id" : "6be83ec4-623e-4840-a417-2fcdf8ad5dfa"
    }

#### Status Codes

Status Code | Description
--- | ---
200 | Successful request.

#### Error Codes

See Error Codes.

Parent topic: Forwarding Policy